Index: /WAeUP_SRP/trunk/skins/waeup_student/add_course_result.py
===================================================================
--- /WAeUP_SRP/trunk/skins/waeup_student/add_course_result.py	(revision 1605)
+++ /WAeUP_SRP/trunk/skins/waeup_student/add_course_result.py	(revision 1606)
@@ -70,5 +70,8 @@
 psm = "You successfully added course %s!" % course_id
 args['portal_status_message'] = psm
-url = context.absolute_url() + '/' + action_after_validate + '?' + urlencode(args)
+if action_after_validate:
+    url = context.absolute_url() + '/' + action_after_validate + '?' + urlencode(args)
+else:
+    url = context.absolute_url() + '?' + urlencode(args)
 return REQUEST.RESPONSE.redirect(url)
 
Index: /WAeUP_SRP/trunk/skins/waeup_student/delete_course_result.py
===================================================================
--- /WAeUP_SRP/trunk/skins/waeup_student/delete_course_result.py	(revision 1605)
+++ /WAeUP_SRP/trunk/skins/waeup_student/delete_course_result.py	(revision 1606)
@@ -38,5 +38,9 @@
 args = {}
 args['portal_status_message'] = message
-url = context.absolute_url() + '/' + action_after_validate + '?' + urlencode(args)
+
+if action_after_validate:
+    url = context.absolute_url() + '/' + action_after_validate + '?' + urlencode(args)
+else:
+    url = context.absolute_url() + '?' + urlencode(args)
 if REQUEST is not None:
     return REQUEST.RESPONSE.redirect(url)
Index: /WAeUP_SRP/trunk/skins/waeup_student/refresh_level.py
===================================================================
--- /WAeUP_SRP/trunk/skins/waeup_student/refresh_level.py	(revision 1605)
+++ /WAeUP_SRP/trunk/skins/waeup_student/refresh_level.py	(revision 1606)
@@ -112,4 +112,7 @@
 psm = "Course list updated!"
 args['portal_status_message'] = psm
-url = context.absolute_url() + '/' + action_after_validate + '?' + urlencode(args)
+if action_after_validate:
+    url = context.absolute_url() + '/' + action_after_validate + '?' + urlencode(args)
+else:
+    url = context.absolute_url() + '?' + urlencode(args)
 return REQUEST.RESPONSE.redirect(url)
Index: /WAeUP_SRP/trunk/skins/waeup_student/register_courses.py
===================================================================
--- /WAeUP_SRP/trunk/skins/waeup_student/register_courses.py	(revision 1605)
+++ /WAeUP_SRP/trunk/skins/waeup_student/register_courses.py	(revision 1606)
@@ -19,5 +19,5 @@
         pass
 
-from urllib import urlencode        
+from urllib import urlencode
 
 request = context.REQUEST
@@ -47,4 +47,7 @@
 psm = "You successfully submitted your course list!"
 args['portal_status_message'] = psm
-url = context.absolute_url() + '/' + action_after_validate + '?' + urlencode(args)
+if action_after_validate:
+    url = context.absolute_url() + '/' + action_after_validate + '?' + urlencode(args)
+else:
+    url = context.absolute_url() + '?' + urlencode(args)
 return REQUEST.RESPONSE.redirect(url)
Index: /WAeUP_SRP/trunk/skins/waeup_student/reject_courses.py
===================================================================
--- /WAeUP_SRP/trunk/skins/waeup_student/reject_courses.py	(revision 1605)
+++ /WAeUP_SRP/trunk/skins/waeup_student/reject_courses.py	(revision 1606)
@@ -46,4 +46,7 @@
 args['continue'] = action_after_validate
 args['portal_status_message'] = psm
-url = context.absolute_url() + '/' + action_after_reject + '?' + urlencode(args)
+if action_after_validate:
+    url = context.absolute_url() + '/' + action_after_validate + '?' + urlencode(args)
+else:
+    url = context.absolute_url() + '?' + urlencode(args)
 return REQUEST.RESPONSE.redirect(url)
Index: /WAeUP_SRP/trunk/skins/waeup_student/study_level_view.pt
===================================================================
--- /WAeUP_SRP/trunk/skins/waeup_student/study_level_view.pt	(revision 1605)
+++ /WAeUP_SRP/trunk/skins/waeup_student/study_level_view.pt	(revision 1606)
@@ -113,4 +113,8 @@
                        type="submit" name="register_courses:method"
                        class="context" value="Submit" />
+                       
+                <input type="hidden" name="action_after_validate" type="text" id="action_after_validate"
+                       tal:attributes="value string:study_level_view"/>                         
+                       
             </td>
           </tr>