Index: /WAeUP_SRP/trunk/WAeUPTables.py
===================================================================
--- /WAeUP_SRP/trunk/WAeUPTables.py	(revision 1624)
+++ /WAeUP_SRP/trunk/WAeUPTables.py	(revision 1625)
@@ -236,9 +236,9 @@
                          'StudentStudyCourse',
                          )
-                         
+
     def __init__(self):
         WAeUPTable.__init__(self, 'students_catalog')
         return
-    
+
     def get_review_state(self,sid,application_doc,clearance_doc,personal_doc,study_course_doc): ###(
         "return the students review_state from portal_catalog"
@@ -280,5 +280,5 @@
             return None
         return getattr(application_doc,'jamb_reg_no',None)
-    
+
     def get_faculty(self,sid,application_doc,clearance_doc,personal_doc,study_course_doc):
         "return the students faculty"
@@ -302,5 +302,5 @@
             return None
         return getattr(clearance_doc,'matric_no',None)
-        
+
     def get_name(self,sid,application_doc,clearance_doc,personal_doc,study_course_doc):
         "return the students name from the personal"
@@ -332,5 +332,5 @@
         """ re-index everything we can find """
         students_folder = self.portal_url.getPortalObject().campus.students
-        
+
         cat = self._catalog
         paths = self._catalog.uids.items()
@@ -346,5 +346,5 @@
             p = paths[i]
             sid = p[0]
-            pcat_res = self.portal_catalog(id=sid) 
+            pcat_res = self.portal_catalog(id=sid)
             if len(pcat_res) != 1:
                 continue
@@ -399,6 +399,6 @@
                          'Total time: %s\n'
                          'Total CPU time: %s' % (`elapse`, `c_elapse`)))
-        
-        
+
+
     security.declarePrivate('notify_event_listener')
     def notify_event_listener(self,event_type,object,infos):
@@ -435,5 +435,5 @@
             student_id = infos['rpath'].split('/')[2]
             self.fixName(student_id)
-            
+
 
 InitializeClass(StudentsCatalog)
@@ -453,8 +453,8 @@
 ###)
 
-class OnlinePaymentTransactions(WAeUPTable): ###(
+class OnlinePaymentsImport(WAeUPTable): ###(
 
     meta_type = 'WAeUP Online Payment Transactions'
-    name = "online_payment_transactions"
+    name = "online_payments_import"
     key = "order_id"
     def __init__(self):
Index: /WAeUP_SRP/trunk/WAeUPTool.py
===================================================================
--- /WAeUP_SRP/trunk/WAeUPTool.py	(revision 1624)
+++ /WAeUP_SRP/trunk/WAeUPTool.py	(revision 1625)
@@ -538,5 +538,5 @@
         #from pdb import set_trace
         current = DateTime.DateTime().strftime("%d-%m-%y_%H_%M_%S")
-        opt = self.online_payment_transactions
+        opt = self.online_payments_import
         students_folder = self.portal_url.getPortalObject().campus.students
         start = True
@@ -562,9 +562,9 @@
                 format_error = format + ',"%(Error)s"'
             data = {}
-            data['datetime'] = date = DateTime.DateTime(pay_transaction['Date']) 
-            data['student_id'] = student_id = pay_transaction['Payer ID'] 
-            data['order_id'] = order_id = pay_transaction['Order ID (Tranx Ref)'] 
-            data['response_code'] = response_code = pay_transaction['Resp Code'] 
-            data['amount'] = amount = pay_transaction['Amount'] 
+            data['datetime'] = date = DateTime.DateTime(pay_transaction['Date'])
+            data['student_id'] = student_id = pay_transaction['Payer ID']
+            data['order_id'] = order_id = pay_transaction['Order ID (Tranx Ref)']
+            data['response_code'] = response_code = pay_transaction['Resp Code']
+            data['amount'] = amount = pay_transaction['Amount']
             dup = False
             if response_code == "12":
Index: /WAeUP_SRP/trunk/doc/srp_documentation.mm
===================================================================
--- /WAeUP_SRP/trunk/doc/srp_documentation.mm	(revision 1624)
+++ /WAeUP_SRP/trunk/doc/srp_documentation.mm	(revision 1625)
@@ -8,5 +8,5 @@
 </node>
 <node CREATED="1172489529057" ID="Freemind_Link_43083883" MODIFIED="1172489545651" POSITION="right" TEXT="SRP Data Structure">
-<node CREATED="1170079621592" FOLDED="true" ID="Freemind_Link_1297017754" MODIFIED="1170079640872" TEXT="Campus">
+<node CREATED="1170079621592" ID="Freemind_Link_1297017754" MODIFIED="1170079640872" TEXT="Campus">
 <node CREATED="1171710559043" ID="Freemind_Link_1592396213" MODIFIED="1171710565212" TEXT="Id: campus"/>
 <node CREATED="1170079643589" FOLDED="true" ID="Freemind_Link_1231068129" MODIFIED="1171710686426" TEXT="Academic Section">
@@ -48,8 +48,8 @@
 </node>
 </node>
-<node CREATED="1170082138244" FOLDED="true" ID="Freemind_Link_1354366927" MODIFIED="1171710679266" TEXT="Student Section">
+<node CREATED="1170082138244" ID="Freemind_Link_1354366927" MODIFIED="1171710679266" TEXT="Student Section">
 <node CREATED="1171709784119" ID="_" MODIFIED="1171709937449" TEXT="Type: StudentsFolder" VSHIFT="104"/>
 <node CREATED="1171710545564" ID="Freemind_Link_221165828" MODIFIED="1171710551332" TEXT="Id: students"/>
-<node CREATED="1170082147831" FOLDED="true" ID="Freemind_Link_115332414" MODIFIED="1171709774415" TEXT="{Student}">
+<node CREATED="1170082147831" ID="Freemind_Link_115332414" MODIFIED="1171709774415" TEXT="{Student}">
 <node CREATED="1171114205479" ID="Freemind_Link_1051911128" LINK="../profiles/default/types/Student.xml" MODIFIED="1171353141707" TEXT="Type: Student"/>
 <node CREATED="1171124926993" ID="Freemind_Link_1838352082" LINK="../profiles/default/schemas/student.xml" MODIFIED="1171353152905" TEXT="Schema: student"/>
@@ -171,5 +171,5 @@
 </node>
 </node>
-<node CREATED="1170082392807" FOLDED="true" ID="Freemind_Link_1979443941" MODIFIED="1171711179966" TEXT="Study Course">
+<node CREATED="1170082392807" ID="Freemind_Link_1979443941" MODIFIED="1171711179966" TEXT="Study Course">
 <node CREATED="1170930140692" ID="Freemind_Link_607082969" MODIFIED="1171009488850" TEXT="Id: study_course"/>
 <node CREATED="1170930264337" ID="Freemind_Link_1384807180" LINK="../profiles/default/types/StudentStudyCourse.xml" MODIFIED="1172159914623" TEXT="Type: StudentStudyCourse"/>
Index: /WAeUP_SRP/trunk/exportimport.py
===================================================================
--- /WAeUP_SRP/trunk/exportimport.py	(revision 1624)
+++ /WAeUP_SRP/trunk/exportimport.py	(revision 1625)
@@ -90,5 +90,5 @@
                                               roles=('SectionReader',))
             students.manage_setLocalGroupRoles(groupid = 'CourseAdvisers',
-                                              roles=('SectionReader',))                                              
+                                              roles=('SectionReader',))
             students.manage_setLocalGroupRoles(groupid='MemberAdmins',
                                          roles=('SectionOfficer',))
@@ -120,5 +120,5 @@
     importWAeUPTable(site.courses_catalog, '', context,'courses_catalog')
     importWAeUPTable(site.payments_catalog, '', context,'payments_catalog')
-    importWAeUPTable(site.online_payment_transactions, '', context,'online_payment_transactions')
+    importWAeUPTable(site.online_payments_import, '', context,'online_payments_import')
     importWAeUPTable(site.portal_pins, '', context,'pins')
     importWAeUPTable(site.portal_pumeresults, '', context,'pumeresults')
Index: eUP_SRP/trunk/profiles/default/online_payment_transactions.xml
===================================================================
--- /WAeUP_SRP/trunk/profiles/default/online_payment_transactions.xml	(revision 1624)
+++ 	(revision )
@@ -1,18 +1,0 @@
-<?xml version="1.0"?>
-<?xml-stylesheet type="text/xsl" href="catalog.xsl"?>
-<object name="courses_catalog" meta_type="WAeUP Table">
- <column value="datetime"/>
- <column value="student_id"/>
- <column value="order_id"/>
- <column value="response_code"/>
- <column value="amount"/>
- <index name="student_id" meta_type="FieldIndex">
-  <indexed_attr value="student_id"/>
- </index>
- <index name="datetime" meta_type="DateIndex">
-  <indexed_attr value="datetime"/>
- </index>
- <index name="order_id" meta_type="FieldIndex">
-  <indexed_attr value="order_id"/>
- </index>
-</object>
Index: /WAeUP_SRP/trunk/profiles/default/online_payments_import.xml
===================================================================
--- /WAeUP_SRP/trunk/profiles/default/online_payments_import.xml	(revision 1625)
+++ /WAeUP_SRP/trunk/profiles/default/online_payments_import.xml	(revision 1625)
@@ -0,0 +1,18 @@
+<?xml version="1.0"?>
+<?xml-stylesheet type="text/xsl" href="catalog.xsl"?>
+<object name="courses_catalog" meta_type="WAeUP Table">
+ <column value="datetime"/>
+ <column value="student_id"/>
+ <column value="order_id"/>
+ <column value="response_code"/>
+ <column value="amount"/>
+ <index name="student_id" meta_type="FieldIndex">
+  <indexed_attr value="student_id"/>
+ </index>
+ <index name="datetime" meta_type="DateIndex">
+  <indexed_attr value="datetime"/>
+ </index>
+ <index name="order_id" meta_type="FieldIndex">
+  <indexed_attr value="order_id"/>
+ </index>
+</object>
Index: /WAeUP_SRP/trunk/profiles/default/toolset.xml
===================================================================
--- /WAeUP_SRP/trunk/profiles/default/toolset.xml	(revision 1624)
+++ /WAeUP_SRP/trunk/profiles/default/toolset.xml	(revision 1625)
@@ -7,6 +7,6 @@
  <required tool_id="payments_catalog"
            class="Products.WAeUP_SRP.WAeUPTables.PaymentsCatalog"/>
- <required tool_id="online_payment_transactions"
-           class="Products.WAeUP_SRP.WAeUPTables.OnlinePaymentTransactions"/>
+ <required tool_id="online_payments_import"
+           class="Products.WAeUP_SRP.WAeUPTables.OnlinePaymentsImport"/>
  <required tool_id="portal_pins"
            class="Products.WAeUP_SRP.WAeUPTables.PinTable"/>
Index: /WAeUP_SRP/trunk/skins/waeup_epayment/check_online_payments.py
===================================================================
--- /WAeUP_SRP/trunk/skins/waeup_epayment/check_online_payments.py	(revision 1624)
+++ /WAeUP_SRP/trunk/skins/waeup_epayment/check_online_payments.py	(revision 1625)
@@ -27,5 +27,5 @@
 member_id = str(member)
 student_id = context.getStudentId()
-online_transactions = context.online_payment_transactions
+online_transactions = context.online_payments_import
 try:
     from Products.zdb import set_trace
@@ -47,5 +47,5 @@
 online_payments = aq_portal(query1 & query2)
 set_trace()
-online_transactions = context.online_payment_transactions
+online_transactions = context.online_payments_import
 
 for op_brain in online_payments:
Index: /WAeUP_SRP/trunk/skins/waeup_epayment/check_transactions.py
===================================================================
--- /WAeUP_SRP/trunk/skins/waeup_epayment/check_transactions.py	(revision 1624)
+++ /WAeUP_SRP/trunk/skins/waeup_epayment/check_transactions.py	(revision 1625)
@@ -27,5 +27,5 @@
 member_id = str(member)
 student_id = context.getStudentId()
-online_transactions = context.online_payment_transactions
+online_transactions = context.online_payments_import
 def rwrite(s):
     response.setHeader('Content-type','text/html; charset=ISO-8859-15')